/*****************************************************************************************
 Copyright (c) 2002-2004 The UbixOS Project
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are
 permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice, this list of
 conditions, the following disclaimer and the list of authors.  Redistributions in binary
 form must reproduce the above copyright notice, this list of conditions, the following
 disclaimer and the list of authors in the documentation and/or other materials provided
 with the distribution. Neither the name of the UbixOS Project nor the names of its
 contributors may be used to endorse or promote products derived from this software
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id$

*****************************************************************************************/

#include <ubixos/exec.h>
#include <ubixos/sched.h>
#include <ubixos/ld.h>
#include <ubixos/kpanic.h>
#include <vmm/vmm.h>
#include <lib/kmalloc.h>
#include <lib/kprintf.h>

/*****************************************************************************************

 Function:   execThread(void (*)(void),int,char *);
 Description: This function will create a thread from code in the current memory space

 Notes:
 
 05/19/04 - This does not work the way I want it to it still makes a copy of kernel space
            so do not use out side of kernel space

*****************************************************************************************/
uInt32 execThread(void (* tproc)(void),int stack,char *arg) {
  kTask_t * newProcess;
  /* Find A New Thread */
  newProcess = schedNewTask();

  /* Set All The Correct Thread Attributes */
  newProcess->tss.back_link    = 0x0;
  newProcess->tss.esp0         = 0x0;
  newProcess->tss.ss0          = 0x0;
  newProcess->tss.esp1         = 0x0;
  newProcess->tss.ss1          = 0x0;
  newProcess->tss.esp2         = 0x0;
  newProcess->tss.ss2          = 0x0;
  newProcess->tss.cr3          = (unsigned int)kernelPageDirectory;
  newProcess->tss.eip          = (unsigned int)tproc;
  newProcess->tss.eflags       = 0x206;
  newProcess->tss.esp          = stack;
  newProcess->tss.ebp          = stack;
  newProcess->tss.esi          = 0x0;
  newProcess->tss.edi          = 0x0;

  newProcess->tss.es           = 0x10;
  newProcess->tss.cs           = 0x08;
  newProcess->tss.ss           = 0x10;
  newProcess->tss.ds           = 0x10;
  newProcess->tss.fs           = 0x10;
  newProcess->tss.gs           = 0x10;
  newProcess->tss.ldt          = 0x18;

  newProcess->tss.trace_bitmap = 0x0000;
  newProcess->tss.io_map       = 0x8000;
  newProcess->oInfo.vmStart    = 0x6400000;

  /* Set up default stack for thread here filled with arg list 3 times */
  asm volatile(
    "pusha               \n"
    "movl   %%esp,%%ecx  \n"
    "movl   %1,%%eax     \n"
    "movl   %%eax,%%esp  \n"
    "pushl  %%ebx        \n"
    "pushl  %%ebx        \n"
    "pushl  %%ebx        \n"
    "movl   %%esp,%%eax  \n"
    "movl   %%eax,%1     \n"
    "movl   %%ecx,%%esp  \n"
    "popa                \n"
    :
    : "b" (arg),"m" (newProcess->tss.esp)
    );

  /* Put new thread into the READY state */
  newProcess->state = READY;

  /* Return with the new process ID */
  return((uInt32)newProcess);
  }

/*****************************************************************************************

 Function: void execFile(char *file);
 Description: This Function Executes A Kile Into A New VM Space With Out
              Having To Fork
 Notes:

 07/30/02 - I Have Made Some Heavy Changes To This As Well As Fixed A Few
            Memory Leaks The Memory Allocated To Load The Binary Into Is
            Now Unmapped So It Can Be Used Again And Not Held Onto Until
            The Program Exits

 07/30/02 - Now I Have To Make A Better Memory Allocator So We Can Set Up
            The Freshly Allocated Pages With The Correct Permissions

*****************************************************************************************/
void execFile(char *file,int argc,char **argv,int console) {

  int     i      = 0x0;
  int     x      = 0x0;
  uInt32  eStart = 0x0;
  char   *newLoc = 0x0;
  char   *linker = 0x0;

  fileDescriptor   *tmpFd         = 0x0;
  elfHeader        *binaryHeader  = 0x0;
  elfProgramHeader *programHeader = 0x0;

  /* Get A New Task For This Proccess */
  _current = schedNewTask();
  _current->gid = 0;
  _current->uid = 0;

  /* Now We Must Create A Virtual Space For This Proccess To Run In */
  _current->tss.cr3 = (uInt32)vmmCreateVirtualSpace(_current->id);

  /* To Better Load This Application We Will Switch Over To Its VM Space */
  asm volatile(
    "movl %0,%%eax          \n"
    "movl %%eax,%%cr3       \n"
    : : "d" ((uInt32 *)(_current->tss.cr3))
    );

  /* Lets Find The File */
  tmpFd = fopen(file,"r");

  /* If We Dont Find the File Return */
  if (!tmpFd) {
   // kprintf("Exec Format Error: Binary File Not Executable.\n");
    fclose(tmpFd);
    return;
    }
  if (tmpFd->perms == 0) {
    //kprintf("Exec Format Error: Binary File Not Executable.\n");
    fclose(tmpFd);
    return;
    }

  /* Load ELF Header */
  binaryHeader = (elfHeader *)kmalloc(sizeof(elfHeader));
  fread(binaryHeader,sizeof(elfHeader),1,tmpFd);


  /* Check If App Is A Real Application */
  if ((binaryHeader->eIdent[1] != 'E') && (binaryHeader->eIdent[2] != 'L') && (binaryHeader->eIdent[3] != 'F')) {
    //kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eType != 2) {
    //kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eEntry == 0x300000) {
    //kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }

  /* Load The Program Header(s) */
  programHeader = (elfProgramHeader *)kmalloc(sizeof(elfProgramHeader)*binaryHeader->ePhnum);
  fseek(tmpFd,binaryHeader->ePhoff,0);
  fread(programHeader,(sizeof(elfProgramHeader)*binaryHeader->ePhnum),1,tmpFd);

  /* Loop Through The Header And Load Sections Which Need To Be Loaded */
  for (i=0;i<binaryHeader->ePhnum;i++) {
    if (programHeader[i].phType == 1) {
      newLoc = (char *)programHeader[i].phVaddr;
      /*
      Allocate Memory Im Going To Have To Make This Load Memory With Correct
      Settings so it helps us in the future
      */
      for (x=0;x<=(programHeader[i].phMemsz+4095);x += 0x1000) {
        if (vmmRemapPage(vmmFindFreePage(_current->id),((programHeader[i].phVaddr & 0xFFFFF000) + x)) == 0x0) {
          kpanic("Error: vmmFindFreePage Failed\n");
          }
        kmemset(((programHeader[i].phVaddr & 0xFFFFF000) + x),0x0,0x1000);
        }
      _current->oInfo.vmStart = ((programHeader[i].phVaddr & 0xFFFFF000) + 0x1900000);
      /* Now Load Section To Memory */
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(newLoc,programHeader[i].phFilesz,1,tmpFd);
      }
    else if (programHeader[i].phType == 2) {
      newLoc = (char *)programHeader[i].phVaddr;
      //elfDynamicS = (elfDynamic *)programHeader[i].phVaddr;
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(newLoc,programHeader[i].phFilesz,1,tmpFd);
      }
    else if (programHeader[i].phType == 3) {
      linker = (char *)kmalloc(programHeader[i].phMemsz);
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(linker,programHeader[i].phFilesz,1,tmpFd);
      }
    }


  /* Set Virtual Memory Start */
  _current->oInfo.vmStart = ((programHeader[i].phVaddr & 0xFFFFF000) + 0x1900000);
  /* Get The Starting Point */
  eStart = binaryHeader->eEntry;

  /* Now Lets Make A Clean Stack */
  newLoc = (char *)0x5DB000;
  vmmRemapPage(vmmFindFreePage(_current->id),0x5DC000);
  vmmSetPageAttribute(0x5DC000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5DB000);
  vmmSetPageAttribute(0x5DB000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5DA000);
  vmmSetPageAttribute(0x5DA000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5D9000);
  vmmSetPageAttribute(0x5D9000,(pageDefault | pageStack));

  i = 0x5DD000;

  vmmRemapPage(vmmFindFreePage(_current->id),0x5D3000);
  vmmSetPageAttribute(0x5D3000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5D2000);
  vmmSetPageAttribute(0x5D2000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5D1000);
  vmmSetPageAttribute(0x5D1000,(pageDefault | pageStack));
  vmmRemapPage(vmmFindFreePage(_current->id),0x5D0000);
  vmmSetPageAttribute(0x5D0000,(pageDefault | pageStack));

  /* Set All The Proper Information For The Task */
  _current->tss.back_link    = 0x0;
  _current->tss.esp0         = 0x5D4000;
  _current->tss.ss0          = 0x10;
  _current->tss.esp1         = 0x0;
  _current->tss.ss1          = 0x0;
  _current->tss.esp2         = 0x0;
  _current->tss.ss2          = 0x0;
  _current->tss.eip          = (long)eStart;
  _current->tss.eflags       = 0x206;
  _current->tss.esp          = i-12;
  _current->tss.ebp          = i;
  _current->tss.esi          = 0x0;
  _current->tss.edi          = 0x0;

  /* Set these up to be ring 3 tasks */
  _current->tss.es           = 0x30+3;
  _current->tss.cs           = 0x28+3;
  _current->tss.ss           = 0x30+3;
  _current->tss.ds           = 0x30+3;
  _current->tss.fs           = 0x30+3;
  _current->tss.gs           = 0x30+3;

  _current->tss.ldt          = 0x18;
  _current->tss.trace_bitmap = 0x0000;
  _current->tss.io_map       = 0x8000;
  _current->state            = READY;

  /* Set up the defaault stack to be used by this new process */

  /*
  asm volatile(
    "pusha               \n"
    "movl   %%esp,%%edx  \n"
    "movl   %2,%%ecx     \n"
    "movl   %%ecx,%%esp  \n"
    "pushl  $0x0         \n"
    "pushl  $0x0         \n"
    "pushl  $0x0         \n"
    "pushl  $0x0         \n"
    "pushl  %%ebx        \n"
    "pushl  %%eax        \n"
    "movl   %%esp,%%ecx  \n"
    "movl   %%ecx,%2     \n"
    "movl   %%edx,%%esp  \n"
    "popa                \n"
    :
    : "a" (argc), "b" (argv), "m" (_current->tss.esp)
    );
  */

  kfree(binaryHeader);
  kfree(programHeader);
  fclose(tmpFd);

  /* Switch Back To The Kernels VM Space */
  asm volatile(
    "movl %0,%%eax          \n"
    "movl %%eax,%%cr3       \n"
    : : "d" ((uInt32 *)(kernelPageDirectory))
    );

  /* Finally Return */
  return;
  }

/*****************************************************************************************

 Function: void sysExec();
 Description: This Is The System Call To Execute A New Task

 Notes:
 04-22-03 - It Now Loads Sections Not The Full File

*****************************************************************************************/
void sysExec(char *file,int argc,char **argv) {
  int    i            = 0x0;
  int    x            = 0x0;
  uInt32 eStart       = 0x0;
  uInt32 *tmp         = 0x0;
  uInt32  ldAddr      = 0x0;
  char   *newLoc      = 0x0;

  fileDescriptor   *tmpFd         = 0x0;
  elfHeader        *binaryHeader  = 0x0;
  elfProgramHeader *programHeader = 0x0;
  elfSectionHeader *sectionHeader = 0x0;
  elfDynamic       *elfDynamicS   = 0x0;


  tmpFd = fopen(file,"r");

  /* If We Dont Find the File Return */
  if (tmpFd == 0x0) {
    kprintf("Couldn't open file %s\n",file);
    return;
    }
  if (tmpFd->perms == 0) {
    //kprintf("Exec Format Error: Binary File Not Executable.\n");
    fclose(tmpFd);
    return;
    }

  /* Load ELF Header */
  binaryHeader = (elfHeader *)kmalloc(sizeof(elfHeader));
  fread(binaryHeader,sizeof(elfHeader),1,tmpFd);
  /* Set sectionHeader To Point To Loaded Binary To We Can Gather Info */

  /* Check If App Is A Real Application */
  if ((binaryHeader->eIdent[1] != 'E') && (binaryHeader->eIdent[2] != 'L') && (binaryHeader->eIdent[3] != 'F')) {
    //kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eType != 2) {
    //kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }
  else if (binaryHeader->eEntry == 0x300000) {
    //kprintf("Exec Format Error: Binary File Not Executable.\n");
    kfree(binaryHeader);
    fclose(tmpFd);
    return;
    }

  /* Load The Program Header(s) */
  programHeader = (elfProgramHeader *)kmalloc(sizeof(elfProgramHeader)*binaryHeader->ePhnum);
  fseek(tmpFd,binaryHeader->ePhoff,0);
  fread(programHeader,(sizeof(elfProgramHeader)*binaryHeader->ePhnum),1,tmpFd);

  sectionHeader = (elfSectionHeader *)kmalloc(sizeof(elfSectionHeader)*binaryHeader->eShnum);
  fseek(tmpFd,binaryHeader->eShoff,0);
  fread(sectionHeader,sizeof(elfSectionHeader)*binaryHeader->eShnum,1,tmpFd);

  /* Loop Through The Header And Load Sections Which Need To Be Loaded */
  for (i=0;i<binaryHeader->ePhnum;i++) {
    if (programHeader[i].phType == 1) {
      newLoc = (char *)programHeader[i].phVaddr;
      /*
      Allocate Memory Im Going To Have To Make This Load Memory With Correct
      Settings so it helps us in the future
      */
      for (x=0;x<(programHeader[i].phMemsz+4095);x+=0x1000) {
        vmmRemapPage(vmmFindFreePage(_current->id),((programHeader[i].phVaddr & 0xFFFFF000) + x));
        kmemset(((programHeader[i].phVaddr & 0xFFFFF000) + x),0x0,0x1000);
        }
      _current->oInfo.vmStart = ((programHeader[i].phVaddr & 0xFFFFF000) + 0x1900000);
      /* Now Load Section To Memory */
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(newLoc,programHeader[i].phFilesz,1,tmpFd);
      }
    else if (programHeader[i].phType == 2) {
      newLoc = (char *)programHeader[i].phVaddr;
      elfDynamicS = (elfDynamic *)programHeader[i].phVaddr;
      fseek(tmpFd,programHeader[i].phOffset,0);
      fread(newLoc,programHeader[i].phFilesz,1,tmpFd);
      }
    else if (programHeader[i].phType == 3) {
      ldAddr = ldEnable();
      }
    }

  for (i=0;i<12;i++) {
    if (elfDynamicS[i].dynVal == 0x3) {
      tmp = (uInt32 *)elfDynamicS[i].dynPtr;
      tmp[2] = (uInt32)ldAddr;
      tmp[1] = (uInt32)tmpFd;
      break;
      }
    }

  /* Get The Starting Point */
  eStart = binaryHeader->eEntry;

  /* Now That We Relocated The Binary We Can Unmap And Free Header Info */
  kfree(binaryHeader);
  kfree(programHeader);

  /* Jump To Start Of New Binary */
  asm volatile(
    "pushl  %1     \n"
    "pushl  %%eax  \n"
    "call  *%0     \n"
    :
    : "g" (eStart),"g" (argv),"a" (argc)
    );
  }

/***
 $Log$
 Revision 1.39  2004/06/18 15:29:38  reddawg
 zero out memory

 Revision 1.38  2004/06/18 15:18:04  reddawg
 bug fixes: did some double checking on pointers and 0x0 out memory

 Revision 1.37  2004/06/17 13:05:14  reddawg
 dynamic linking: fixed int6 issue problem was multiple rel's

 Revision 1.36  2004/06/17 12:28:56  reddawg
 debug: show me the output after this is a tested

 Revision 1.35  2004/06/17 02:58:49  reddawg
 Cleaned Out Dead Code

 Revision 1.34  2004/06/17 02:19:29  reddawg
 Cleaning out dead code

 Revision 1.32  2004/06/17 02:00:53  reddawg
 Test

 Revision 1.31  2004/06/17 01:57:52  reddawg
 Test

 Revision 1.30  2004/06/17 01:37:00  reddawg
 TCA: test now

 Revision 1.29  2004/06/16 17:46:42  reddawg
 Cleaned Dead Code

 Revision 1.28  2004/06/16 17:04:13  reddawg
 ld.so: rest of the commit

 Revision 1.25  2004/06/15 23:46:05  reddawg
 Nig Nog

 Revision 1.24  2004/06/14 13:16:26  reddawg
 Works now 0x1000 line 272

 Revision 1.21  2004/06/14 12:45:12  reddawg
 Fixed!!!

 Revision 1.20  2004/06/14 12:40:48  reddawg
 Try now

 Revision 1.18  2004/06/14 12:20:54  reddawg
 notes: many bugs repaired and ld works 100% now.

 Revision 1.17  2004/06/12 01:27:26  reddawg
 shared objects: yes we almost fully support shared objects

 Revision 1.16  2004/06/10 13:08:00  reddawg
 Minor Bug Fixes

 Revision 1.15  2004/06/04 13:29:56  reddawg
 libc: modified mkdir(); interface
 kpanic: kPanic(); now says kPanic: %s
 system: now reboots when receives message for reboot
         also when command start sde is received by system the STD is started

 Revision 1.14  2004/06/01 00:04:53  reddawg
 Try now mark

 Revision 1.13  2004/05/25 22:44:08  reddawg
 Removed debug code

 Revision 1.12  2004/05/22 21:46:37  reddawg
 Fixed some bugs

 Revision 1.11  2004/05/22 02:10:42  reddawg
 Added Code To Debug ISsue

 Revision 1.10  2004/05/21 21:15:04  reddawg
 Fixed a few bugs which prevented the system from loadin

 Revision 1.9  2004/05/21 15:34:23  reddawg
 Fixed a couple of typo

 Revision 1.8  2004/05/21 15:32:06  reddawg
 Changed the sys fileExec works it just loads sections needed now instead of fully should be a performance increase of about 40%

 Revision 1.7  2004/05/19 04:31:12  reddawg
 Fixed some typedef problems in exec

 Revision 1.6  2004/05/19 04:07:42  reddawg
 kmalloc(size,pid) no more it is no kmalloc(size); the way it should of been

 Revision 1.5  2004/05/19 01:21:29  reddawg
 Tweaked

 Revision 1.4  2004/05/15 02:30:28  reddawg
 Lots of changes

 Revision 1.3  2004/05/02 03:19:51  reddawg
 Added Spinlock Provision For SMP

 Revision 1.2  2004/04/30 14:16:04  reddawg
 Fixed all the datatypes to be consistant uInt8,uInt16,uInt32,Int8,Int16,Int32

 Revision 1.1.1.1  2004/04/15 12:07:18  reddawg
 UbixOS v1.0

 Revision 1.44  2004/04/13 16:16:44  reddawg
 Changed our copyright, it is all now under a BSD-Style license

 END
 ***/
